"use strict";
const routing_controllers_1 = require("routing-controllers");
const Utils_1 = require("../util/Utils");
const ParamTypes_1 = require("routing-controllers/metadata/types/ParamTypes");
function EntityFromCookie(paramName, options) {
    return function (object, methodName, index) {
        const reflectedType = Reflect.getMetadata("design:paramtypes", object, methodName)[index];
        const target = options && options.type ? options.type : reflectedType;
        if (!target)
            throw new Error("Cannot guess type if the parameter");
        routing_controllers_1.defaultMetadataArgsStorage().params.push({
            method: methodName,
            name: paramName,
            index: index,
            type: ParamTypes_1.ParamTypes.COOKIE,
            reflectedType: reflectedType,
            parseJson: options && options.parseJson,
            isRequired: options && options.required,
            // format: target,
            target: object.constructor,
            transform: value => Utils_1.entityTransform(value, target, options)
        });
    };
}
exports.EntityFromCookie = EntityFromCookie;
//# sourceMappingURL=EntityFromCookie.js.map