"use strict";
const typeorm_1 = require("typeorm");
/**
 * @internal
 */
function entityTransform(value, target, options) {
    const connection = typeorm_1.getConnectionManager().get(options ? options.connectionName : undefined);
    const repository = connection.getRepository(target);
    if (options) {
        if (options.many) {
            if (!options.property)
                throw new Error("Conditional property must be set to perform a query to multiple objects.");
            return repository.find({ [options.property]: value });
        }
        else if (options.property) {
            return repository.findOne({ [options.property]: value });
        }
    }
    return repository.findOneById(value);
}
exports.entityTransform = entityTransform;
//# sourceMappingURL=Utils.js.map